Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.pool
Interface ObjectPool

All Known Implementing Classes:
  BaseObjectPool, GenericObjectPool, SoftReferenceObjectPool, StackObjectPool

    public interface ObjectPool

A pooling interface.

`ObjectPool` defines a trivially simple pooling interface. The only required methods are `borrowObject`, `returnObject` and `invalidateObject`.

Example of use:

     Object obj = null;

     try {
         obj = pool.borrowObject();
         try {
             //...use the object...
         } catch(Exception e) {
             // invalidate the object
             pool.invalidateObject(obj);
             // do not return the object to the pool twice
             obj = null;
         } finally {
             // make sure the object is returned to the pool
             if(null != obj) {
                 pool.returnObject(obj);
            }
         }
     } catch(Exception e) {
           // failed to borrow an object
     }

See `BaseObjectPool` for a simple base implementation.

Since:
  Pool 1.0
Version:
  $Revision: 962893 $ $Date: 2010-07-10 10:37:27 -0700 (Sat, 10 Jul 2010) $
Author:
  Rodney Waldhoff, Sandy McArthur
See Also:
  `PoolableObjectFactory`, `ObjectPoolFactory`, `KeyedObjectPool`, `BaseObjectPool`

Method Summary
`void` | `addObject()` Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool.
`Object` | `borrowObject()` Obtains an instance from this pool.
`void` | `clear()` Clears any objects sitting idle in the pool, releasing any associated resources (optional operation).
`void` | `close()` Close this pool, and free any resources associated with it.
`int` | `getNumActive()` Return the number of instances currently borrowed from this pool (optional operation).
`int` | `getNumIdle()` Return the number of instances currently idle in this pool (optional operation).
`void` | `invalidateObject(Object obj)` Invalidates an object from the pool.
`void` | `returnObject(Object obj)` Return an instance to the pool.
`void` | `setFactory(PoolableObjectFactory factory)` Deprecated. to be removed in pool 2.0

Method Detail

### borrowObject

    Object borrowObject()
                        throws Exception,
                               NoSuchElementException,
                               IllegalStateException

  Obtains an instance from this pool.

  Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then validated with `validateObject`.

  By contract, clients must return the borrowed instance using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface.

  The behaviour of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations). Older versions of this method would return `null` to indicate exhaustion, newer versions are encouraged to throw a `NoSuchElementException`.

  Returns:
    an instance from this pool.
  Throws:
    `IllegalStateException` - after `close` has been called on this pool.
    `Exception` - when `makeObject` throws an exception.
    `NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance.

### returnObject

    void returnObject(Object obj)
                      throws Exception

  Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface.

  Parameters:
    `obj` - a `borrowed` instance to be returned.
  Throws:
    `Exception`

### invalidateObject

    void invalidateObject(Object obj)
                          throws Exception

  Invalidates an object from the pool.

  By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface.

  This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

  Parameters:
    `obj` - a `borrowed` instance to be disposed.
  Throws:
    `Exception`

### addObject

    void addObject()
                   throws Exception,
                          IllegalStateException,
                          UnsupportedOperationException

  Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool. `addObject` is useful for "pre-loading" a pool with idle objects. (Optional operation).

  Throws:
    `Exception` - when `PoolableObjectFactory.makeObject()` fails.
    `IllegalStateException` - after `close()` has been called on this pool.
    `UnsupportedOperationException` - when this pool cannot add new idle objects.

### getNumIdle

    int getNumIdle()
                   throws UnsupportedOperationException

  Return the number of instances currently idle in this pool (optional operation). This may be considered an approximation of the number of objects that can be `borrowed` without creating any new instances. Returns a negative value if this information is not available.

  Returns:
    the number of instances currently idle in this pool or a negative value if unsupported
  Throws:
    `UnsupportedOperationException` - deprecated: if this implementation does not support the operation

### getNumActive

    int getNumActive()
                     throws UnsupportedOperationException

  Return the number of instances currently borrowed from this pool (optional operation). Returns a negative value if this information is not available.

  Returns:
    the number of instances currently borrowed from this pool or a negative value if unsupported
  Throws:
    `UnsupportedOperationException` - deprecated: if this implementation does not support the operation

### clear

    void clear()
               throws Exception,
                      UnsupportedOperationException

  Clears any objects sitting idle in the pool, releasing any associated resources (optional operation). Idle objects cleared must be `destroyed`.

  Throws:
    `UnsupportedOperationException` - if this implementation does not support the operation
    `Exception`

### close

    void close()
               throws Exception

  Close this pool, and free any resources associated with it.

  Calling `addObject()` or `borrowObject()` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

  Throws:
    `Exception` - deprecated: implementations should silently fail if not all resources can be freed.

### setFactory

    void setFactory(PoolableObjectFactory factory)
                    throws IllegalStateException,
                           UnsupportedOperationException

  Deprecated. to be removed in pool 2.0

  Sets the `factory` this pool uses to create new instances (optional operation). Trying to change the `factory` after a pool has been used will frequently throw an `UnsupportedOperationException`. It is up to the pool implementation to determine when it is acceptable to call this method.

  Parameters:
    `factory` - the `PoolableObjectFactory` used to create new instances.
  Throws:
    `IllegalStateException` - when the factory cannot be set at this time
    `UnsupportedOperationException` - if this implementation does not support the operation

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2011 The Apache Software Foundation. All Rights Reserved.